#ifndef __WHITELIST_DB_H
#define __WHITELIST_DB_H

#include <limits.h>
#include <gm/sm3.h>

#define KYSEC		1

#define HASH_MAX	256
#define SHA1_SIZE	(SM3_DIGEST_LENGTH * 2)

#ifdef __cplusplus
extern "C" {
#endif

enum {
	TYPE_BINARY=0,
	TYPE_SCRIPT,
	TYPE_SHLIB,
	TYPE_KMOD,
	TYPE_FPROT,
	TYPE_DEB,
	TYPE_OTHER
};

struct white_list{
	char fpath[PATH_MAX];
	char hash[SHA1_SIZE + 1];
	int kpro;
	int os;
};

int whitelstAdd(int type, char *fpath, int kpro, int os);
int whitelstDelete(int type, char *fpath);

int whitelstAddByDeb(char *debname);
int whitelstDeleteByDeb(char *debname);

int whitelstAddByDir(int type, char *dpath);
int whitelstUpdateByDir(int type, char *dpath);
int whitelstDeleteByDir(int type, char *dpath);

/*
 * 获取对应表的行数 
 */
int getWhitelstCount(int type, char *search);

/* 
 * 获取对应表中所有的数据
 * num: 是上面的函数getWhitelstCount()返回的值, 用于构造white_list的大小
 */
struct white_list * whitelstShowByType(int type, int num, char *search);

/* log */
int audit_record(char *op, char *file, char *hash, int res);
int audit_record_for_kysec(char *op, int res);

/* syslog */
void log_debug(const char *fmt, ...);
void log_error(const char *fmt, ...);

#ifdef __cplusplus
}
#endif

#endif
